Imports Microsoft.PointOfService
Imports System.Text


Public Class Form1
    WithEvents myExplorer As PosExplorer
    WithEvents myMSR As Msr



    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        myExplorer = New PosExplorer(Me)
        Dim device As DeviceInfo = myExplorer.GetDevice("Msr", "myMSR")
        If device Is Nothing Then
            lblStatus.Text = "No MSR found"
            Update()
        Else
            myMSR = myExplorer.CreateInstance(device)
            myMSR.Open()
            myMSR.Claim(1000)
            myMSR.DeviceEnabled = True
            myMSR.DataEventEnabled = True
            myMSR.DecodeData = True
        End If

    End Sub

    Private Sub myExplorer_DeviceAddedEvent(ByVal sender As Object, ByVal e As Microsoft.PointOfService.DeviceChangedEventArgs) Handles myExplorer.DeviceAddedEvent
        If (e.Device.Type = "Msr") Then
            myMSR = myExplorer.CreateInstance(e.Device)
            lblStatus.Text = "New Msr attached: " & e.Device.ServiceObjectName
            myMSR.Open()
            myMSR.Claim(1000)
            myMSR.DeviceEnabled = True
            myMSR.DataEventEnabled = True
            myMSR.DecodeData = True
            Update()

        End If
    End Sub

    Private Sub myMSR_DataEvent(ByVal sender As Object, ByVal e As Microsoft.PointOfService.DataEventArgs) Handles myMSR.DataEvent
        Dim myEncoding As New ASCIIEncoding

        txtInput.Text = myEncoding.GetString(myMSR.Track2Data)
        lblStatus.Text = "Data Event"
        Update()
        myMSR.DataEventEnabled = True
    End Sub

    Private Sub myExplorer_DeviceRemovedEvent(ByVal sender As Object, ByVal e As Microsoft.PointOfService.DeviceChangedEventArgs) Handles myExplorer.DeviceRemovedEvent
        If (e.Device.Type = "Msr") Then

            lblStatus.Text = "Msr detached"
            myMSR.DataEventEnabled = False
            myMSR.Release()
            myMSR.Close()
            Update()

        End If
    End Sub
End Class
