Imports Microsoft.PointOfService.BaseServiceObjects
Imports Microsoft.PointOfService
Imports System.Text
Imports System

<ServiceObjectAttribute(DeviceType.CashDrawer, "WASP Cash Drawer", "SJJ EMS WASP Cash Drawer SO", 1, 9)> _
Public Class WASPCashDrawerSO
    Inherits CashDrawerBase

    Private m_CommPort As New Rs232

    Public Overrides Function CheckHealth(ByVal level As Microsoft.PointOfService.HealthCheckLevel) As String
        'Verify that device is open, claimed and enabled
        VerifyState(True, True)
        Return CheckHealthText
    End Function

    Public Overrides ReadOnly Property CheckHealthText() As String
        Get
            'Verify that device is open
            VerifyState(False, False)

            CheckHealthText = "ok"

            Return CheckHealthText
        End Get
    End Property

    Public Overrides Function DirectIO(ByVal command As Integer, ByVal data As Integer, ByVal obj As Object) As Microsoft.PointOfService.DirectIOData
        Return New DirectIOData(data, obj)
    End Function

    Protected Overrides Sub OpenDrawerImpl()
        m_CommPort.Port = DevicePath
        m_CommPort.Open()
        m_CommPort.Write(Encoding.ASCII.GetBytes(Chr(27) & Chr(112) & Chr(0) & Chr(25) & Chr(30)))
        m_CommPort.Close()
    End Sub


End Class
