Imports Microsoft.PointOfService
Imports System.Text

Public Class frmMain
    WithEvents myExplore As PosExplorer
    WithEvents myScanner As Scanner

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'TODO: This line of code loads data into the 'InventoryDataSet.Inventory' table. You can move, or remove it, as needed.
        Me.InventoryTableAdapter.Fill(Me.InventoryDataSet.Inventory)

    End Sub

    Private Sub btnReferesh_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReferesh.Click
        Me.InventoryTableAdapter.Fill(Me.InventoryDataSet.Inventory)

    End Sub

    Private Sub btnKeyboard_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnKeyboard.Click
        Process.Start("osk.exe")
    End Sub
    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        myExplore = New PosExplorer(Me)
        Dim device As DeviceInfo = myExplore.GetDevice("Scanner", "mySCanner")
        Dim eFlag As Integer = 0

        Try
            myScanner = myExplore.CreateInstance(device)
        Catch ex As Exception
            lblStatus.Text = "No Scanner Attached - Reconnect or Replace"
            eFlag = 1
        End Try

        If eFlag = 0 Then
            myScanner.Open()
            myScanner.Claim(1000)
            myScanner.DeviceEnabled = True
            myScanner.DataEventEnabled = True
            myScanner.DecodeData = True
        End If
        Update()

    End Sub

    Private Sub myExplore_DeviceAddedEvent(ByVal sender As Object, ByVal e As Microsoft.PointOfService.DeviceChangedEventArgs) Handles myExplore.DeviceAddedEvent
        If (e.Device.Type = "Scanner") Then
            myScanner = myExplore.CreateInstance(e.Device)

            lblStatus.Text = "New bar-code scanner attached"

            myScanner.Open()
            myScanner.Claim(1000)
            myScanner.DeviceEnabled = True
            myScanner.DataEventEnabled = True
            myScanner.DecodeData = True
            Update()
        End If
    End Sub

    Private Sub myExplore_DeviceRemovedEvent(ByVal sender As Object, ByVal e As Microsoft.PointOfService.DeviceChangedEventArgs) Handles myExplore.DeviceRemovedEvent
        If (e.Device.Type = "Scanner") Then

            lblStatus.Text = "Bar-code scanner detached"

            myScanner.DataEventEnabled = False
            myScanner.DeviceEnabled = False
            myScanner.Release()
            myScanner.Close()
            Update()

        End If
    End Sub

    Private Sub myScanner_DataEvent(ByVal sender As Object, ByVal e As Microsoft.PointOfService.DataEventArgs) Handles myScanner.DataEvent

        Dim myEncoding As New ASCIIEncoding
        Dim myScan As String
        Dim cnn1 As New ADODB.Connection
        Dim rst1 As New ADODB.Recordset

        myScan = myEncoding.GetString(myScanner.ScanDataLabel)
        myScanner.DataEventEnabled = True

        cnn1.Open("Provider=Microsoft.Jet.OLEDB.4.0; Data Source=c:\Database\Inventory.mdb")
        Dim str1 As String = "SELECT ItemNo, ItemName, BarCode, QTY, Price FROM Inventory"
        With rst1
            .ActiveConnection = cnn1
            .Open(str1, , ADODB.CursorTypeEnum.adOpenForwardOnly, ADODB.LockTypeEnum.adLockPessimistic)
        End With

        If rbNone.Checked.Equals(True) Or rbIncrement.Checked.Equals(True) Or rbDecrement.Checked.Equals(True) Then
            Do Until rst1.EOF
                Dim ItemNo As String = CStr(rst1("ItemNo").Value)
                Dim ItemName As String = rst1("ItemName").Value
                Dim BarCode As String = rst1("BarCode").Value
                Dim QTY As Integer = rst1("QTY").Value
                Dim Price As String = rst1("Price").Value

                If BarCode = myScan Then

                    txtProductName.Text = ItemName
                    If rbNone.Checked.Equals(True) Then

                        txtPrice.Text = Price
                        txtQTY.Text = QTY.ToString
                        txtScanTrack2.Text = BarCode
                        lblStatus.Text = "Ready"

                    ElseIf rbIncrement.Checked.Equals(True) Then

                        QTY = QTY + 1
                        txtQTY.Text = QTY.ToString
                        rst1("QTY").Value = QTY
                        txtQTY.Text = QTY.ToString
                        txtScanTrack2.Text = BarCode
                        lblStatus.Text = "QTY increased"
                        rst1.Save()

                    ElseIf rbDecrement.Checked.Equals(True) Then

                        QTY = QTY - 1
                        txtQTY.Text = QTY.ToString
                        rst1("QTY").Value = QTY
                        txtQTY.Text = QTY.ToString
                        txtScanTrack2.Text = BarCode
                        lblStatus.Text = "QTY decreased"
                        rst1.Save()

                    End If

                    Exit Do
                End If

                rst1.MoveNext()
            Loop

        ElseIf rbAdd.Checked.Equals(True) Then


            txtScanTrack2.Text = myEncoding.GetString(myScanner.ScanDataLabel)
            rst1("QTY").Value = 1
            txtQTY.Text = "1"
            myScanner.DataEventEnabled = True
        End If

      
        Update()

        rst1.Close()
        rst1 = Nothing
        cnn1.Close()
        cnn1 = Nothing

    End Sub

    Private Sub rbAdd_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbAdd.CheckedChanged
        If rbAdd.Checked.Equals(True) Then

            btnAdd.Enabled = True

        ElseIf rbAdd.Checked.Equals(False) Then

            btnAdd.Enabled = False
        End If
    End Sub

    Private Sub btnAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAdd.Click
        Dim cnn1 As New ADODB.Connection
        Dim rst1 As New ADODB.Recordset

        cnn1.Open("Provider=Microsoft.Jet.OLEDB.4.0; Data Source=c:\Database\Inventory.mdb")
        Dim str1 As String = "SELECT ItemNo, ItemName, BarCode, QTY, Price FROM Inventory"
        With rst1
            .ActiveConnection = cnn1
            .Open(str1, , ADODB.CursorTypeEnum.adOpenForwardOnly, ADODB.LockTypeEnum.adLockPessimistic)
        End With

        If txtProductName.Text = "" Or txtPrice.Text = "" Or txtScanTrack2.Text = "" Or txtQTY.Text = "" Then
            lblStatus.Text = "Need to fill in all fields"
        Else
            'If there are no records trap and move on
            Try
                rst1.MoveLast()
            Catch ex As Exception

            End Try

            rst1.AddNew()
            rst1("ItemName").Value = txtProductName.Text.ToString
            rst1("BarCode").Value = txtScanTrack2.Text.ToString
            rst1("QTY").Value = txtQTY.Text.ToString
            rst1("Price").Value = txtPrice.Text.ToString
            rst1.Save()
            lblStatus.Text = txtProductName.Text.ToString & " added to database"
        End If
        Update()

        'Close the database connection
        rst1.Close()
        rst1 = Nothing
        cnn1.Close()
        cnn1 = Nothing

        'Refresh Datagrid
        Me.InventoryTableAdapter.Fill(Me.InventoryDataSet.Inventory)

    End Sub


End Class
